//
// BUG0496.CPP
//
// This program demonstrates a code generation bug in
// the 16 bit version of BCC 4.5x.  When compiled with
// the following command line:
//
//  bcc -Ol bug0496.cpp
//
// foo() mistakenly writes the value 64
// to the stack, even though i is a register
// based variable.  Writing out a value to
// a random location on the stack is a bad
// thing.  In this case, it wipes out the stored
// bp from the calling routine.  The main
// routine detects this error, prints it
// out, and attempts to deal with it by
// calling the abort() function.
//

#include <iostream.h>
#include <stdlib.h>


char array[ 64 ];

void foo()
{
    for( int i = 0 ; i < 64 ; i++ )
        array[ i ] = 5;
}

main()
{
    int a = 1;
    int b = 2;
    int c = 3;
    static int good_bp = _BP;
    foo();

    cout << "a  = " << a << "  (should be 1)\n";
    cout << "b  = " << b << "  (should be 2)\n";
    cout << "c  = " << c << "  (should be 3)\n";
    cout << "bp = " << _BP << "  (should be "
         << good_bp << ")\n";
    abort();
    return a + b + c;
}

//End of file

