/* gendat.c - generate a data file of fixed-length text records
 *
 * Syntax:
 *     gendat <recsize> <nrecords>
 */

#include <stdio.h>
#include <stdlib.h>

void Usage(void)
    {
    fprintf(stderr, "Usage: gendat <recsize> <nrecords>\n");
    exit(EXIT_FAILURE);
    }

void GenRec(FILE* Out, int RecSize)
    {
    int i;
    static char* Line = 0;
    static char  Alpha[26*2]; /* A-Z,a-z */
    if(!Line)
        {
        Line    = malloc(RecSize + 1);
        for(i = 0; i < 26*2; ++i)
            Alpha[i] = (i%26) + ('a'^(' '*(i<26)));
        }
    for(i = 0; i < RecSize-2; ++i)
        Line[i] = Alpha[rand()%(26*2)];
    Line[i++] = '\n';
    Line[i] = '\0';
    fputs(Line, Out);
    }


void GenDat(int RecSize, int NRecs)
    {
    FILE* Out = fopen("memfile.dat", "w");
    int   i;
    for(i = 0; i < NRecs; ++i)
        GenRec(Out, RecSize);
    fclose(Out);
    }

void main(int argc, char** argv)
    {
    if(argc != 3)
        Usage();
    else
        {
        int RecSize, NRecs;
        RecSize = atoi(argv[1]);
        NRecs   = atoi(argv[2]);
        GenDat(RecSize, NRecs);
        }
    exit(EXIT_SUCCESS);
    }
