#include <stdio.h>
#include <stdlib.h>
#include <stdarg.h>
#include <windows.h>


const char* INPUTFILE="memfile.dat";

void Usage(void)
    {
    fprintf(stderr,
        "Usage: qsort <filename> <RecordSize> <nrecords>\n");
    exit(EXIT_FAILURE);
    }

int Compare(const void*a, const void*b)
    {    return strncmp(a,b,78);    }

void main(int argc, char** argv)
    {
    int     RecordSize, NRecords;
    HANDLE  InFile, Map;
    void*   Mem;
    
    if(argc != 4)
        Usage();

    InFile = CreateFile(argv[1], GENERIC_WRITE | GENERIC_READ, 0,
        NULL, OPEN_EXISTING, 0, 0);
    if(!InFile)
        {
        fprintf(stderr, "Can't open '%s'\n", argv[1]);
        Usage();
        }
    RecordSize = atoi(argv[2]);
    NRecords  = atoi(argv[3]);
    if(RecordSize <= 0 || NRecords <= 0)
        Usage();
    Map = CreateFileMapping(InFile, 0, PAGE_READWRITE, 0,
        RecordSize*NRecords, 0);

    Mem = MapViewOfFile(Map, FILE_MAP_WRITE, 0, 0, 0);

    qsort(Mem, NRecords, RecordSize, Compare);

    FlushViewOfFile(Mem, 0);
    UnmapViewOfFile(Mem);
    CloseHandle(Map);
    CloseHandle(InFile);
    exit(EXIT_SUCCESS);
    }

